

Mega208 = {};

function Mega208.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Mega208:load(xmlFile)
------------------------------------------
	------ Keys ------------
	------------------------------------------

self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;



	  local rotationPartNoderpmMeter = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartrpmMeter#index"));
    if rotationPartNoderpmMeter ~= nil then
        self.rotationPartrpmMeter = {};
        self.rotationPartrpmMeter.node = rotationPartNoderpmMeter;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartrpmMeter#minRot"));
        self.rotationPartrpmMeter.minRot = {};
        self.rotationPartrpmMeter.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrpmMeter.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrpmMeter.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartrpmMeter#maxRot"));
        self.rotationPartrpmMeter.maxRot = {};
        self.rotationPartrpmMeter.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrpmMeter.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrpmMeter.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartrpmMeter.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartrpmMeter#rotTime"), 2)*1000;
        self.rotationPartrpmMeter.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartrpmMeter#touchRotLimit"), 10));
    end;


	 local rotationPartNodehidra1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra1#index"));
    if rotationPartNodehidra1 ~= nil then
        self.rotationParthidra1 = {};
        self.rotationParthidra1.node = rotationPartNodehidra1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra1#minRot"));
        self.rotationParthidra1.minRot = {};
        self.rotationParthidra1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra1#maxRot"));
        self.rotationParthidra1.maxRot = {};
        self.rotationParthidra1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra1#rotTime"), 2)*1000;
        self.rotationParthidra1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra1#touchRotLimit"), 10));
    end;

	local rotationPartNodeabl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl1#index"));
    if rotationPartNodeabl1 ~= nil then
        self.rotationPartabl1 = {};
        self.rotationPartabl1.node = rotationPartNodeabl1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl1#minRot"));
        self.rotationPartabl1.minRot = {};
        self.rotationPartabl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl1#maxRot"));
        self.rotationPartabl1.maxRot = {};
        self.rotationPartabl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#rotTime"), 2)*1000;
        self.rotationPartabl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#touchRotLimit"), 10));
    end;
    local rotationPartNodeabl2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl2#index"));
    if rotationPartNodeabl2 ~= nil then
        self.rotationPartabl2 = {};
        self.rotationPartabl2.node = rotationPartNodeabl2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl2#minRot"));
        self.rotationPartabl2.minRot = {};
        self.rotationPartabl2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl2#maxRot"));
        self.rotationPartabl2.maxRot = {};
        self.rotationPartabl2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#rotTime"), 2)*1000;
        self.rotationPartabl2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#touchRotLimit"), 10));
    end;

        local rotationPartNodehidra2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra2#index"));
    if rotationPartNodehidra2 ~= nil then
        self.rotationParthidra2 = {};
        self.rotationParthidra2.node = rotationPartNodehidra2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra2#minRot"));
        self.rotationParthidra2.minRot = {};
        self.rotationParthidra2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra2#maxRot"));
        self.rotationParthidra2.maxRot = {};
        self.rotationParthidra2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra2#rotTime"), 2)*1000;
        self.rotationParthidra2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra2#touchRotLimit"), 10));
    end;
      local rotationPartNodehidra3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra3#index"));
    if rotationPartNodehidra3 ~= nil then
        self.rotationParthidra3 = {};
        self.rotationParthidra3.node = rotationPartNodehidra3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra3#minRot"));
        self.rotationParthidra3.minRot = {};
        self.rotationParthidra3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra3#maxRot"));
        self.rotationParthidra3.maxRot = {};
        self.rotationParthidra3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra3#rotTime"), 2)*1000;
        self.rotationParthidra3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra3#touchRotLimit"), 10));
    end;
	local rotationPartNodeletra = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.letra#index"));
    if rotationPartNodeletra ~= nil then
        self.rotationPartletra = {};
        self.rotationPartletra.node = rotationPartNodeletra;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartletra#minRot"));
        self.rotationPartletra.minRot = {};
        self.rotationPartletra.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartletra.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartletra.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.letra#maxRot"));
        self.rotationPartletra.maxRot = {};
        self.rotationPartletra.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartletra.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartletra.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartletra.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.letra#rotTime"), 2)*1000;
        self.rotationPartletra.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.letra#touchRotLimit"), 10));
    end;

	self.testNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.test#index"));
	self.testMaxDisplacement = 0.001865;
	self.testMinDisplacement = -0.001865;
	self.testDirection = true;


	local munkahengerNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.munkahenger#index"));
    if munkahengerNode ~= nil then
        self.munkahenger = {};
        self.munkahenger.node = munkahengerNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger#minRot"));
        self.munkahenger.minRot = {};
        self.munkahenger.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.munkahenger.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.munkahenger.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger#maxRot"));
        self.munkahenger.maxRot = {};
        self.munkahenger.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.munkahenger.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.munkahenger.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.munkahenger.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger#rotTime"), 2)*1000;
        self.munkahenger.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger#touchRotLimit"), 10));
    end;

	local munkahenger2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.munkahenger2#index"));
	if munkahenger2 ~= nil then
		self.munkahenger2 = {};
		self.munkahenger2.node = munkahenger2;
		local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger2#minTranslation"));
		self.munkahenger2.minTranslation = {};
		self.munkahenger2.minTranslation[1] = x;
		self.munkahenger2.minTranslation[2] = y;
		self.munkahenger2.minTranslation[3] = z;

		x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.munkahenger2#maxTranslation"));
		self.munkahenger2.maxTranslation = {};
		self.munkahenger2.maxTranslation[1] = x;
		self.munkahenger2.maxTranslation[2] = y;
		self.munkahenger2.maxTranslation[3] = z;

        self.munkahenger2.translationTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger2#translationTime"), 2)*1000;
        self.munkahenger2.touchTransLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.munkahenger2#touchTransLimit"), 10));
	end;

 local attachNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.attach#index"));
    if attachNode ~= nil then
        self.attach = {};
        self.attach.node = attachNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.attach#minRot"));
        self.attach.minRot = {};
        self.attach.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.attach.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.attach.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.attach#maxRot"));
        self.attach.maxRot = {};
        self.attach.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.attach.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.attach.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.attach.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.attach#rotTime"), 2)*1000;
        self.attach.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.attach#touchRotLimit"), 10));
    end;

	self.extraPipeWheatParticleSystem = {};
    self.extraPipeWheatParticleSystemindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extraPipeWheatParticleSystem#index"));
    Utils.loadParticleSystem(xmlFile, self.extraPipeWheatParticleSystem, "vehicle.extraPipeWheatParticleSystem", self.extraPipeWheatParticleSystemindex, false, nil, self.baseDirectory);

    self.extraPipeRapeParticleSystem = {};
    self.extraPipeRapeParticleSystemindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extraPipeRapeParticleSystem#index"));
    Utils.loadParticleSystem(xmlFile, self.extraPipeRapeParticleSystem, "vehicle.extraPipeRapeParticleSystem", self.extraPipeRapeParticleSystemindex, false, nil, self.baseDirectory);

	self.extraPipeSunflowerParticleSystem = {};
    self.extraPipeSunflowerParticleSystemindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extraPipeSunflowerParticleSystem#index"));
    Utils.loadParticleSystem(xmlFile, self.extraPipeSunflowerParticleSystem, "vehicle.extraPipeSunflowerParticleSystem", self.extraPipeSunflowerParticleSystemindex, false, nil, self.baseDirectory);

	-- Sounds --

    BatteurSoundFile = Utils.getFilename("Sounds/MegaArat2.wav", self.baseDirectory);
    self.BatteurSoundId = createSample("BatteurSound");
    loadSample(self.BatteurSoundId, BatteurSoundFile, false);
    self.BatteurPlaying = false;

    BatteurStartSoundFile = Utils.getFilename("Sounds/MegaAratStart.wav", self.baseDirectory);
    self.BatteurStartSoundId = createSample("BatteurStartSound");
    loadSample(self.BatteurStartSoundId, BatteurStartSoundFile, false);
    self.BatteurStartPlaying = false;

    BatteurStopSoundFile = Utils.getFilename("Sounds/MegaAratStop.wav", self.baseDirectory);
    self.BatteurStopSoundId = createSample("BatteurStopSound");
    loadSample(self.BatteurStopSoundId, BatteurStopSoundFile, false);
    self.BatteurStopPlaying = false;
self.rotorFan2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotorFan2#index"));
self.intCameraIndex = 2;
	self.cameraCount  = 2;

	self.internalCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.internalCamera#index"));
	if self.camPositionX == nil then
		self.camPositionX = 0;
	end;

	if self.camPositionZ == nil then
		self.camPositionZ = 0;
	end;



	-- selfs --

self.TreshedNumber = 0;
self.TreshedTotalNumber = 0;
self.BatteurOK = false;
self.ThreshingActive = false;
self.ThreshingSound = false;
self.threasherActivationTime = 2500;
self.reelTime = 0;
self.orgUnloadCapacity = self.grainTankUnloadingCapacity;
self.feederSpeedValue = 14;
self.feedSpeed = self.feederSpeedValue;
self.reelSpeedValue = 1.1;
self.isCutterStarted = false;
self.threshingTime = 0;
self.timeoutCutterShutdown = true;
self.HUDActive = true;
self.lastThreasherRoundPerMinute = 0;
self.rotorSpeedValue = 350;
self.actualRotorSpeedValue = 0;
self.engineRunTime = 0;
self.reelSpeedAdjustMode = 0;
self.shiftMode = 1;
self.pipeUnloadState = 1;



-- HUD --

	self.HUDpath = Utils.getFilename("HUD.png", self.baseDirectory);
	self.HUDWidth = 0.100;
    self.HUDHeight = 0.22;
	self.HUDPoxX = 0.89;
    self.HUDPoxY = 0.65
    self.HUDOverlay = Overlay:new("HUD", self.HUDpath, self.HUDPoxX, self.HUDPoxY, self.HUDWidth, self.HUDHeight);
self.Rotor = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Rotor#index"));
end;
function Mega208:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)

self.camPositionX = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionX"), 0);
	self.camPositionZ = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionZ"), 0);

local TreshedTotalNumber =  Utils.getNoNil(getXMLFloat(xmlFile, key.."#TreshedTotalNumber"),0);
   self.TreshedTotalNumber = TreshedTotalNumber;
    return BaseMission.VEHICLE_LOAD_OK;

end;



function Mega208:delete()

	if self.hudInfoBaseOverlay ~= nil then
		self.hudInfoBaseOverlay:delete();
	end;



    delete(self.BatteurStartSoundId);

    delete(self.BatteurStopSoundId);
    delete(self.BatteurSoundId);


end;

function Mega208:getSaveAttributesAndNodes(nodeIdent)
local TreshedTotalNumber= Utils.getNoNil(self.TreshedTotalNumber, 10);

    local attributes = 'TreshedTotalNumber="'..string.format("%.1f",TreshedTotalNumber)..'"';
   return attributes, nil;
end;



function Mega208:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Mega208:keyEvent(unicode, sym, modifier, isDown)

if self.isMotorStarted then
if isDown and sym == Input.KEY_home then
		if self.pipeUnloadState < 2 then
			self.pipeUnloadState = self.pipeUnloadState + 1;
		else
			self.pipeUnloadState = 1;
		end;
	end;
end;
	--if isDown and sym == Input.KEY_l and self.isMotorStarted then
			--renderText(0.5, 0.9350, 0.040, string.format());
    	if isDown and sym == self.keys.Batteur and self.isMotorStarted then self.actualRotorSpeedValue = self.actualRotorSpeedValue/self.threasherActivationTime * self.threshingTime;
			self.ThreshingActive = not self.ThreshingActive;
			self.ThreshingSound = not self.ThreshingSound;
			self.BatteurOK = not self.BatteurOK;
			local BatteurSoundOffset = 4050;
			self.playBatteurSoundTime = self.time+BatteurSoundOffset;
		end

		if isDown and sym == self.keys.HUD then
			self.HUDActive = not self.HUDActive;
		end;
if isDown and sym == Input.KEY_KP_9 then
			if 	self.shiftMode == 1 then
				self.reelSpeedAdjustMode = 1;
			end;
		else
			if 	self.shiftMode == 1 then
				self.reelSpeedAdjustMode = 0;
			end;
		end;

		if isDown and sym == Input.KEY_KP_7 then
			if 	self.shiftMode == 1 then
				self.reelSpeedAdjustMode = -1;
			end;
		end;
	if sym == Input.KEY_pagedown then
		self.attachMax = isDown;
		self.munkahengerMax = isDown;
		self.munkahenger2Max = isDown;
	end;
	if sym == Input.KEY_pageup then
		self.attachMin = isDown;
		self.munkahengerMin = isDown;
		self.munkahenger2Min = isDown;
	end;
	if isDown and sym == Input.KEY_n then
		self.rotationMaxabl1 = not self.rotationMaxabl1;
	end;
	if isDown and sym == Input.KEY_n then
		self.rotationMaxabl2 = not self.rotationMaxabl2;
	end;

	if isDown and sym == Input.KEY_n then
		self.rotationMaxhidra2 = not self.rotationMaxhidra2;
	end;
        	if isDown and sym == Input.KEY_n then
		self.rotationMaxhidra3 = not self.rotationMaxhidra3;
        end;
	if isDown and sym == Input.KEY_k then
		self.rotationMaxletra = not self.rotationMaxletra;
	end;
	if isDown and sym == Input.KEY_m then
		self.rotationMaxhidra1 = not self.rotationMaxhidra1;
	end;

	end;

function Mega208:update(dt)

local rpm = 3;
	local engineRpm = 3;



	--if self.rpmMeterValue ~= nil then
	if self.enabledPowershiftGearBox and not self.isAIThreshing and not self.isAutopilotActivated then
		rpm = self.rpmMeterValue / self.motorMaxRpmLimit[3] * 3;
	else
		rpm = self.throttlePercentage * 3;
	end;

	if rpm > 3 then
		rpm = 3;
	end;

	engineRpm = rpm;
 if self.isMotorStarted and self.ThreshingActive and self.rotorFan2 ~= nil then
          rotate(self.rotorFan2, dt*0.0045 * rpm, 0, 0);
        end;
if self.isMotorStarted then
		if self.rotationPartrpmMeter ~= nil then
			local x, y, z = getRotation(self.rotationPartrpmMeter.node);
			z = ((self.rotationPartrpmMeter.maxRot[3] - self.rotationPartrpmMeter.minRot[3]) / self.motorMaxRpmLimit[3]) * self.rpmMeterValue + self.rotationPartrpmMeter.minRot[3];
			setRotation(self.rotationPartrpmMeter.node, x, y, z);
		end;
		end;
		if self.rotationPartrpmMeter ~= nil then
			if not self.isMotorStarted then
		local x, y, z = getRotation(self.rotationPartrpmMeter.node);
		z = 160;
			setRotation(self.rotationPartrpmMeter.node, x, y, z);
		end;
		end;

if self.pipeUnloadState == 2 then
	self.pipeIsUnloading = true;
	self.pipeParticleActivated = true;
	self.pipeOpening = true;
	self.grainTankUnloadingCapacity = rpm * self.orgUnloadCapacity;
else
	self.pipeIsUnloading = false;
	self.grainTankUnloadingCapacity = 0;
	self.pipeParticleActivated = false;
				end;

if self.rotationParthidra1 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra1.maxRot, self.rotationParthidra1.minRot, 3, self.rotationParthidra1.rotTime, dt, not self.rotationMaxhidra1);
		   setRotation(self.rotationParthidra1.node, unpack(newRot));
        end;

	if self.rotationPartabl1 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl1.maxRot, self.rotationPartabl1.minRot, 3, self.rotationPartabl1.rotTime, dt, not self.rotationMaxabl1);
		   setRotation(self.rotationPartabl1.node, unpack(newRot));
        end;
        if self.rotationPartabl2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl2.maxRot, self.rotationPartabl2.minRot, 3, self.rotationPartabl2.rotTime, dt, not self.rotationMaxabl2);
		   setRotation(self.rotationPartabl2.node, unpack(newRot));
        end;

        if self.rotationParthidra2 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra2.maxRot, self.rotationParthidra2.minRot, 3, self.rotationParthidra2.rotTime, dt, not self.rotationMaxhidra2);
		   setRotation(self.rotationParthidra2.node, unpack(newRot));
        end;
        if self.rotationParthidra3 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra3.maxRot, self.rotationParthidra3.minRot, 3, self.rotationParthidra3.rotTime, dt, not self.rotationMaxhidra3);
		   setRotation(self.rotationParthidra3.node, unpack(newRot));
        end;

if self.rotationPartletra ~= nil then
		   local x, y, z = getRotation(self.rotationPartletra.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartletra.maxRot, self.rotationPartletra.minRot, 3, self.rotationPartletra.rotTime, dt, not self.rotationMaxletra);
		   setRotation(self.rotationPartletra.node, unpack(newRot));
        end;


local doRotate = self.munkahengerMax or self.munkahengerMin
	if self.munkahenger ~= nil and doRotate then
		local x, y, z = getRotation(self.munkahenger.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.munkahenger.maxRot, self.munkahenger.minRot, 3, self.munkahenger.rotTime, dt, not self.munkahengerMax);
		setRotation(self.munkahenger.node, unpack(newRot));
	end;

	local doTranslate = self.munkahenger2Max or self.munkahenger2Min
	if self.munkahenger2 ~= nil and doTranslate then
		local x, y, z = getTranslation(self.munkahenger2.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.munkahenger2.maxTranslation, self.munkahenger2.minTranslation, 3, self.munkahenger2.translationTime, dt, not self.munkahenger2Max);
		setTranslation(self.munkahenger2.node, unpack(newTrans));
	end;


local doRotate = self.attachMax or self.attachMin
	if self.attach ~= nil and doRotate then
        	local x, y, z = getRotation(self.attach.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.attach.maxRot, self.attach.minRot, 3, self.attach.rotTime, dt, not self.attachMax);
        	setRotation(self.attach.node, unpack(newRot));
	end;

if self.isEntered then
		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMLEFT) then
				self.camPositionX = self.camPositionX + 0.005;
				if self.camPositionX >= 0.4 then
					self.camPositionX = 0.4;
				end;


		end;

		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMRIGHT) then
				self.camPositionX = self.camPositionX - 0.005;
				if self.camPositionX <= -0.4 then
					self.camPositionX = -0.4;
				end;

		end;

		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMFORWARD) then
				self.camPositionZ = self.camPositionZ + 0.005;
				if self.camPositionZ >= 0.3 then
					self.camPositionZ = 0.3;
				end;

		end;

		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMBACK) then
				self.camPositionZ = self.camPositionZ - 0.005;
				if self.camPositionZ <= -0.2 then
					self.camPositionZ = -0.2;
				end;

		end;

		if InputBinding.hasEvent(InputBinding.COMBINEMOVECAMRESET) then
				self.camPositionX = 0;
				self.camPositionZ = 0;
			end;
		end;


	if self.internalCamera ~= nil then
		setTranslation(self.internalCamera, self.camPositionX, 0, self.camPositionZ);
	end;



	if self.isMotorStarted then
		if self.reelSpeedAdjustMode == -1 then
			if self.reelSpeedValue > 0.2 then
				self.reelSpeedValue = self.reelSpeedValue - 0.01;
				--self.feederSpeedValue = self.reelSpeedValue * 5;
			end;
		elseif self.reelSpeedAdjustMode == 1 then
			if self.reelSpeedValue < 3.5 then
				self.reelSpeedValue = self.reelSpeedValue + 0.01;
				--self.feederSpeedValue = self.reelSpeedValue * 5;
			end;
		end;
	end;



	-- Higher unload rate pr. rpm and extra pipe particles

	--self.grainTankUnloadingCapacity = 200;

	if self.pipeIsUnloading and self.grainTankUnloadingCapacity > self.orgUnloadCapacity * 2 then
		if self.grainTankFillLevel > 380 then
		if self.currentGrainTankFruitType == FruitUtil.FRUITTYPE_SUNFLOWER then
				Utils.setEmittingState(self.extraPipeSunflowerParticleSystem, true);
			else
			if self.currentGrainTankFruitType == FruitUtil.FRUITTYPE_RAPE then
				Utils.setEmittingState(self.extraPipeRapeParticleSystem, true);
			else
				Utils.setEmittingState(self.extraPipeWheatParticleSystem, true);
			end;
			end;
		else
			Utils.setEmittingState(self.extraPipeRapeParticleSystem, false);
			Utils.setEmittingState(self.extraPipeWheatParticleSystem, false);
			Utils.setEmittingState(self.extraPipeSunflowerParticleSystem, false);
		end;
	else
		Utils.setEmittingState(self.extraPipeRapeParticleSystem, false);
		Utils.setEmittingState(self.extraPipeWheatParticleSystem, false);
		Utils.setEmittingState(self.extraPipeSunflowerParticleSystem, false);
	end;


	self.actualRotorSpeedValue = self.rotorSpeedValue * rpm;


		-- Threshing Sounds --

	if self.ThreshingSound and self:getIsActiveForSound() then
        if not self.BatteurStartPlaying then
			playSample(self.BatteurStartSoundId, 1, 1, 0);
			self.BatteurStartPlaying = true;
			stopSample(self.BatteurStopSoundId);
			self.BatteurStopPlaying = false;
		end;
	else
        if self.BatteurStartPlaying then
			stopSample(self.BatteurStartSoundId);
			self.BatteurStartPlaying = false;
			playSample(self.BatteurStopSoundId, 1, 1, 0);
			self.BatteurStopPlaying = true;
		end;
	end;

	if self.BatteurSoundId ~= nil then
		local alpha = 0.9;
		local roundPerMinute = self.lastThreasherRoundPerMinute*alpha + (1-alpha)*(self.actualRotorSpeedValue);
		self.lastThreasherRoundPerMinute = roundPerMinute;
		local roundPerSecond = roundPerMinute / 60;
		setSamplePitch(self.BatteurSoundId, math.min(1 + 0.01*math.abs(roundPerSecond), 3));
	end;

	if self.ThreshingSound and self:getIsActiveForSound() then
		if self.playBatteurSoundTime <= self.time then
			if not self.BatteurPlaying then
				playSample(self.BatteurSoundId, 0, 1, 0);
				self.BatteurPlaying = true;
			end;
		end;
	else
			if self.BatteurPlaying then
				stopSample(self.BatteurSoundId);
				self.BatteurPlaying = false;
			end;
	end;

	if not self.isMotorStarted then

	    self.BatteurStartPlaying = false;

	    self.BatteurStopPlaying = false;
	    self.BatteurPlaying = false;

		if self.BatteurPlaying ~= nil then
			stopSample(self.BatteurSoundId);
		end;

	end

-- Slow reel startup and shutoff
	if self.reelTime < self.threasherActivationTime and self.isCutterStarted then
		self.reelTime = self.reelTime + dt;
		if self.reelTime > self.threasherActivationTime then
			self.reelTime = self.threasherActivationTime;
		end;
	end;

	if self.reelTime > 0 and not self.isCutterStarted then
		self.reelTime = self.reelTime - dt/2;
		if self.reelTime < 0 then
			self.reelTime = 0;
		end;
	end;
	--self.reelSpeedValue = self.reelSpeedValue/self.threasherActivationTime * self.reelTime;
	--renderText(0.5, 0.9, 0.040,string.format(rpm));
	--renderText(0.5, 0.8, 0.040,string.format(self.threasherActivationTime));
	--renderText(0.5, 0.7, 0.040,string.format(self.reelTime));
	--renderText(0.5, 0.6, 0.040,string.format(dt));
	local reelRpm = rpm/self.threasherActivationTime * self.reelTime;

-- Slow thresher startup and shutoff
	if self.threshingTime < self.threasherActivationTime and self.ThreshingActive then
		self.threshingTime = self.threshingTime + dt;
		if self.threshingTime > self.threasherActivationTime then
			self.threshingTime = self.threasherActivationTime;
		end;
	end;

	if self.threshingTime > 0 and not self.ThreshingActive then
		self.threshingTime = self.threshingTime - dt/2;
		if self.threshingTime < 0 then
			self.threshingTime = 0;
		end;
	end;
rpm = rpm/self.threasherActivationTime * self.threshingTime;
self.actualRotorSpeedValue = self.actualRotorSpeedValue/self.threasherActivationTime * self.threshingTime;
	-- Threshing Movements --
	--local feederRotation = 0.007 * self.rotorSpeedValue;
	local feederRotation = 0.001 * 	(self.feederSpeedValue/2) * reelRpm;
	local reelRotation = 0.001 * (self.reelSpeedValue/2) * reelRpm;

	feederRotation = feederRotation/self.threasherActivationTime * self.reelTime;
	reelRotation = reelRotation/self.threasherActivationTime * self.reelTime;

	self.feedSpeed = self.feederSpeedValue/3 * engineRpm;

	-- Cutter movements --
for cutter,implement in pairs(self.attachedCutters) do
		if self.isMotorStarted then
			if cutter.rollNode ~= nil then
				rotate(cutter.rollNode, -1 * dt*feederRotation, 0, 0);
			end;
		if cutter.rollNode ~= nil then
				cutter.rollSpeed = -1 * dt*feederRotation;
			end;
			if cutter.reelNode ~= nil then
				rotate(cutter.reelNode, -1 * dt*reelRotation, 0, 0);
			end;


		end;
	end;
	self.isCutterStarted = false;
	for cutter,implement in pairs(self.attachedCutters) do

		self.isCutterStarted = cutter.reelStarted;
	end;

-- Threashing off --
	if not self.isMotorStarted then
		self.ThreshingActive = false;
		self.ThreshingSound = false;
		self.BatteurOK = false;
	    self.BatteurStartPlaying = false;
	    self.BatteurStopPlaying = false;
	    self.BatteurPlaying = false;
		self.Batteur2Playing = false;
		if self.BatteurPlaying ~= nil then
			stopSample(self.BatteurSoundId);
		end;
		if self.threshingSound ~= nil then
			stopSample(self.threshingSound);
		end;
		self:stopThreshing();
	end

	-- Threshing conditions --

	if self.BatteurOK and self.isMotorStarted then
		self.allowsThreshing = true;
	else
		self.allowsThreshing = false;
	end;
	if self.isThreshing then
		local pixelToQm = 2048 / 4096 * 2048 / 4096; -- 4096px are mapped to 2048m
		self.TreshedNumber = self.TreshedNumber + self.lastArea*pixelToQm/(40000);
		self.TreshedTotalNumber = self.TreshedTotalNumber + self.lastArea*pixelToQm/(40000);
		end;

		  if self.testNode ~= nil then
		if self.ThreshingActive then
					local x,y,z = getRotation(self.testNode);
					local displacement = x;
					if displacement >= self.testMaxDisplacement then
						self.testDirection = false;
					end;
					if displacement <= self.testMinDisplacement then
						self.testDirection = true;
					end;

					if self.testDirection then
						displacement = x+(9.7 * rpm/100000);
					else

						displacement = x-(9.7 * rpm/100000);
					end;

					--renderText(0.5, 0.9, 0.040, displacement);

					setRotation(self.testNode, displacement,y,z)
				end;
			end;
			if self.testNode ~= nil then
			if not self.ThreshingActive then
				local x,y,z = getRotation(self.testNode);
				local x = 0;
				setRotation(self.testNode, x,y,z);
			end;
		end;

end;

function Mega208:onLeave()

end;

function Mega208:draw()

	if self.isEntered then
		if self.HUDOverlay ~= nil then
			if self.HUDActive then
				self.HUDOverlay:render();
				setTextBold(true);
				setTextColor(0, 0, 0, 1.0);
				renderText(0.955, 0.74, 0.016, string.format("%.1f", self.TreshedNumber));
				renderText(0.955, 0.725, 0.016, string.format("%.1f", self.TreshedTotalNumber));
		end;
	end;
end;


end;
function Mega208:onDeactivateSounds()
    if self.BatteurPlaying ~= nil then
		stopSample(self.BatteurSoundId);
    end;
	if self.Batteur2Playing ~= nil then
		stopSample(self.Batteur2SoundId);
    end;
	end;
function Mega208:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
function Mega208:openPipe()
    self.pipeOpening = self.rotationMax;
end;
